package qr;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTabbedPane;

import qrcode.QrCode;



public class GUI extends JFrame implements ActionListener, ItemListener{

	private static final long serialVersionUID = 1L;
	Qr qr;
	JTabbedPane tabPane;
	//MidiSetupFrame midiSetup;
	static int WIDTH = 500;
	static int HEIGHT = 320;
	JPanel objectSamplerPanel;
	JButton addObjectSamplerSetPanel;

	public GUI(Qr qr){
		super("Config@'qr: ver1.0'");
		this.qr = qr;
		
		//initMidiSetupFrame();
		
		JPanel groundworkPanel = new JPanel();
		groundworkPanel.setLayout(new BorderLayout());
		tabPane = new JTabbedPane();
		tabPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
		tabPane.setPreferredSize(new Dimension(WIDTH, HEIGHT));
		tabPane.addTab("Help", null, createHelpTab(),
		"qr:̐");
		tabPane.addTab("Display", null, createScreenSetupTab(),
		"XN[̃TCYA\̂Ɋւݒ");
		tabPane.addTab("Object Setting", null, createObjectsSetupTab(),
		"IuWFNg̍ő吔A͂Ɋւݒ");
		groundworkPanel.add(tabPane);
		getContentPane().add(groundworkPanel);
	}
	
	
	/*------------------------------------------------------------------
	 						wvpl
	------------------------------------------------------------------*/
	
	private JPanel createHelpTab(){
		JPanel panel = new JPanel();
		JPanel scriptPanel = new JPanel();
		scriptPanel.setPreferredSize(new Dimension(450, 180));
		scriptPanel.setLayout(new GridLayout(9, 1));
		scriptPanel.add(new JLabel("@qr: ́AgѓdbQRR[hǂݎ邱ƂŁA"));
		scriptPanel.add(new JLabel("Ȃ̌gтyɂAỷt҂ƂĎQł"));
		scriptPanel.add(new JLabel("R~jP[Vc[łI"));
		scriptPanel.add(new JLabel("@XN[QRR[hȂ̌gѓdbœǂݎA"));
		scriptPanel.add(new JLabel("WebɃANZXƁAgѓdbɐVQRR[hƉy܂B"));
		scriptPanel.add(new JLabel("@ANZXID^Aqr:ɓID̃IuWFNg܂B"));
		scriptPanel.add(new JLabel("̃IuWFNg͂Ȃ̌gѓdbƓytł܂B"));
		scriptPanel.add(new JLabel("@FB̌gѓdbłȂ̌gѓdb̉ʏQRR[hǂݎ΁A"));
		scriptPanel.add(new JLabel("qr:ɃIuWFNgƉyAgёt҂ɂ鉉tł܂I"));
		
		panel.add(scriptPanel);
		createBorder(panel, "qr: ");
		return panel;
	}
	/*------------------------------------------------------------------
	 						ʂ̐ݒpl
	------------------------------------------------------------------*/
	
	JButton fullScreenButton;
	JComboBox screenSizeBox;
	
	private JPanel createScreenSetupTab(){
		JPanel panel = new JPanel();
		JPanel northPanel = new JPanel();
		northPanel.setLayout(new BorderLayout());
		JPanel scriptPanel = new JPanel();
		scriptPanel.setPreferredSize(new Dimension(200, 70));
		scriptPanel.setLayout(new GridLayout(4, 1));
		scriptPanel.add(new JLabel("Ev_Ej[炨D݂̉𑜓xIŉB"));
		scriptPanel.add(new JLabel("E삪dƂ́A菬ȉ𑜓xIщB"));
		scriptPanel.add(new JLabel("Efull screen{^ƃtXN[܂B"));
		scriptPanel.add(new JLabel("Efull screenESCL[ŏIł܂B"));
		
		northPanel.add(scriptPanel);
		createBorder(northPanel, "Display Setting ");
		
		panel.setLayout(new BorderLayout());
		
		JPanel centerPanel = new JPanel();
		centerPanel.setLayout(new BorderLayout());
		
		fullScreenButton = new JButton("full screen");
		fullScreenButton.addActionListener(this);
		
		screenSizeBox = new JComboBox();
		for(int i = 0; i < Screen.SCREEN_SIZE.length; i++) {
			String size = Integer.toString(Screen.SCREEN_SIZE[i][0]) + " ~ " +
							Integer.toString(Screen.SCREEN_SIZE[i][1]);
			screenSizeBox.addItem(size);
		}
		screenSizeBox.addItemListener(this);
		screenSizeBox.setSelectedIndex(2);
		
		centerPanel.add(fullScreenButton, BorderLayout.CENTER);
		centerPanel.add(screenSizeBox, BorderLayout.NORTH);
		createBorder(centerPanel, "Display Setting");
		
		panel.add(northPanel, BorderLayout.NORTH);
		panel.add(centerPanel, BorderLayout.CENTER);
		
		return panel;
	}
	
	public void setScreenSize(int no) {
		screenSizeBox.setSelectedIndex(no);
	}
	
	/*------------------------------------------------------------------
		V[PTMIDI̐ݒpl
		------------------------------------------------------------------*/
	JButton updateButton;
	JSpinner maxSpinner, lifeSpinner;
	String[] configWords = {"MAX_NUM", "LIFE_NUM"};
	JCheckBox autoChangingCheckBox;

	
	private JPanel createObjectsSetupTab(){
		JPanel objectsPanel = new JPanel();
		objectsPanel.setLayout(new BorderLayout());
		JPanel northPanel = new JPanel();
		northPanel.setLayout(new BorderLayout());
		JPanel scriptPanel = new JPanel();
		scriptPanel.setPreferredSize(new Dimension(200, 70));
		scriptPanel.setLayout(new GridLayout(4, 1));
		scriptPanel.add(new JLabel("MAX_NUM: IuWFNg̍ő吔łB"));
		scriptPanel.add(new JLabel("         ő吔𒴂ƁAÂ̂Ă܂B"));
		scriptPanel.add(new JLabel("LIFE_NUM: IuWFNg̐͂łB"));
		scriptPanel.add(new JLabel("         ̐Ɠ񐔂̉IuWFNg͏Ă܂B"));
		
		northPanel.add(scriptPanel);
		createBorder(northPanel, "Object Setting ");
		
		JPanel centerPanel = new JPanel();
		centerPanel.setLayout(new BorderLayout());
		JPanel labelPanel = new JPanel();
		labelPanel.setPreferredSize(new Dimension(100, 30));
		labelPanel.setLayout(new GridLayout(configWords.length, 1, 5, 5));
		for(int i = 0; i < configWords.length; i++)
			labelPanel.add(new JLabel(configWords[i]));
		JPanel fieldPanel = new JPanel();
		fieldPanel.setPreferredSize(new Dimension(10, 30));
		fieldPanel.setLayout(new GridLayout(configWords.length, 1, 5, 5));
		fieldPanel.add(maxSpinner = new JSpinner());
		fieldPanel.add(lifeSpinner = new JSpinner());
		maxSpinner.setValue(new Integer(20));
		lifeSpinner.setValue(new Integer(5));
		
 		updateButton = new JButton("Update objects");
		updateButton.addActionListener(this);
		
		autoChangingCheckBox = new JCheckBox("I[gQRR[h؂ւB", QrCode.autoChanging);
        autoChangingCheckBox.setAlignmentX(Component.LEFT_ALIGNMENT);
        autoChangingCheckBox.addItemListener(this);
        
		centerPanel.add(updateButton, BorderLayout.NORTH);
		centerPanel.add(labelPanel, BorderLayout.WEST);
		centerPanel.add(fieldPanel, BorderLayout.CENTER);
		centerPanel.add(autoChangingCheckBox, BorderLayout.SOUTH);
		createBorder(centerPanel, "Objects Setting");
		
		objectsPanel.add(northPanel, BorderLayout.NORTH);
		objectsPanel.add(centerPanel, BorderLayout.CENTER);
		return objectsPanel;
	}
		
	private void updateObjects(){
		int max = spinnerCheck(maxSpinner);
		int life = spinnerCheck(lifeSpinner);
		if(max <= 0 || life <= 0){
			return;
		}
		
		qr.setMAX_NUM(max);
		qr.setLIFE_NUM(life);
	}
	
	private int spinnerCheck(JSpinner spinner){
		int value = 0;
		if(spinner.getValue() instanceof Integer){
			value = ((Integer)spinner.getValue()).intValue();
			if(value <= 0){
				JOptionPane.showMessageDialog(this, "vX̒l͂Ă", 
						"Input Error", JOptionPane.ERROR_MESSAGE);
			}
		}else{
			JOptionPane.showMessageDialog(this, "Ȓl͂Ă܂", 
					"Input Error", JOptionPane.ERROR_MESSAGE);
		}
		return value;
	}
	
	
	
	
	public void createBorder(JPanel p, String s)
	{
		p.setBorder(BorderFactory.createCompoundBorder(
		BorderFactory.createTitledBorder(s),
		BorderFactory.createEmptyBorder(0, 0, 0, 0)));
	}

	/*------------------------------------------------------------------
	 						CxgEXi[
	------------------------------------------------------------------*/
	public void actionPerformed(ActionEvent event) {
		if(event.getSource() == fullScreenButton){
//			Screen.removeApplet();
//			Screen.setFullScreen(true);
//			Screen.setScreenSize(0);
//			Screen.resize();
//			Screen.setScreen(!Code.FULL_SCREEN, Code.SCREEN_SIZE[screenSizeBox.getSelectedIndex()]);
			Screen.fullScreen();
		}else if(event.getSource() == updateButton){
			updateObjects();
		}
	}
	
	public void itemStateChanged(ItemEvent e) {
//		if(e.getSource() == midiOutPresetBox){
//		applyPreset(midiOutPresetBox.getSelectedIndex());
//		}
		Object source = e.getSource();
		if(source == screenSizeBox) {
			if(e.getStateChange() == ItemEvent.SELECTED){
				Screen.setScreenSize(screenSizeBox.getSelectedIndex());
				Screen.resizeScreen();
			}
		}else if(source == autoChangingCheckBox){
			QrCode.autoChanging = autoChangingCheckBox.isSelected();
		}
	}
}
