package qr;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.swing.ImageIcon;

import qr.Screen;
import qr.Reading;
import qr.object.FrontText;
import qr.object.Word;
import qr.synth.Mixer;
import qr.synth.Sequencer;
import qrcode.QrCode;
import processing.core.PApplet;
import processing.core.PFont;

public class Qr extends PApplet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	static GUI gui;

	private int defaultFrameRate = 24;

	static Mixer mixer;

	static Sequencer sequencer;

	static FrontText frontText;

	// private int selected = 0;
	private static int MAX_NUM = 20;
	private static int LIFE_NUM = 5;

	// ReadCGI readCGI;
	Reading[] reading;

	PFont font;

	GL gl;

	private int maxnum = 8; // QRR[h̑

	static Vector soundObj = new Vector();

	// private boolean addSeq = false;
	public void init(GLAutoDrawable drawable) {
		gl.glOrtho(-width / 2, width / 2, -height / 2, height / 2, -10, 10);
	}

	public void setup() {
		try {
			background(255);
			size(Screen.screenSize[0], Screen.QR_HEIGHT, OPENGL);
			perspective();
			float cameraZ = ((width * 3 / 8.0f) / (float) (Math
					.tan(PI * 60.0f / 360.0f)));
			perspective(PI / 3.0f, (float) width / (float) height,
					cameraZ / 10.0f, cameraZ * 10.0f);
			// float fov = (float)Math.PI/3.0f;
			// float cameraZ = (height/2.0f) / (float)Math.tan(Math.PI * fov /
			// 360.0);
			// perspective(fov, (float)width/(float)height,
			// cameraZ/10.0f, cameraZ*10.0f);

			font = loadFont("fonts/QRFont-48.vlw");
//			Screen.resizeScreen();
			gui = new GUI(this);
			gui.setBounds(0, 0, GUI.WIDTH, GUI.HEIGHT);
			gui.setVisible(true);
			gui.setIconImage(new ImageIcon("img/qricon.gif").getImage());

			mixer = new Mixer();
			sequencer = new Sequencer();
			frontText = new FrontText(this);

			reading = new Reading[maxnum];
			for (int i = 0; i < maxnum; i++) {
				URL url = new URL("http://www.sadmb.com/Qr/log" + i + ".dat");
				TextCGI textCGI = new TextCGI(url);
				reading[i] = new Reading(this, textCGI, i);
			}
			// readCGI = new ReadCGI();
			frameRate(defaultFrameRate);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}

	public void draw() {
		background(0);
		frontText.draw();
		for (int i = 0; i < soundObj.size(); i++) {
			((Word) soundObj.elementAt(i)).draw();
		}
		// stroke(255);
		// line(200 + selected * 50, 0, 200 + selected * 50, 10);
	}

	public void addWord(String swf) {
	}

	public static synchronized void addSeq(String swf, String word, int mobnum, int sendmob) {
		Word newWord = new Word(Qr.applet, swf, word, mobnum, sendmob);

		sequencer.add(newWord);
		int usePort = mixer.connectOutputToMixer(newWord.getLineout());
		newWord.setUseMixerPort(usePort);
		soundObj.add(newWord);

		if (soundObj.size() > MAX_NUM) {
			((Word) soundObj.elementAt(0)).destroy();
			deleteWord(0);
		}
	}

	// WordĂяoč폜B
	public static void deleteWord(Word w) {
		soundObj.removeElement(w);
		System.out.println("delete complete :" + w);
	}

	public static void deleteWord(int i) {
		Word w = (Word) soundObj.get(i);
		soundObj.removeElementAt(i);
		System.out.println("delete complete :" + w);
	}

	public void reloadFont() {
		font = loadFont("fonts/QRFont-48.vlw");
	}
	
	public void reloadFront(){
		if(frontText != null)
			frontText.reloadFront();
	}
	
	public void setMiddleFont() {
		int fontsize = (int)(48 * (float)(Screen.screenSize[0] / 1024.0f));
		textFont(font, fontsize);
	}

	public PFont getMiddleFont() {
		return font;
	}

	public int getMiddleFontSize() {
		int fontsize = (int)(48 * (float)(Screen.screenSize[0] / 1024.0f));
		return fontsize;
	}

	public void keyPressed() {
		applet2.keyPressed();
	}
	
	public void setMAX_NUM(int MAX_NUM){
		Qr.MAX_NUM = MAX_NUM;
	}
	
	public void setLIFE_NUM(int LIFE_NUM){
		Qr.LIFE_NUM = LIFE_NUM;
	}
	
	public int getMAX_NUM(){
		return MAX_NUM;
	}
	
	public int getLIFE_NUM(){
		return LIFE_NUM;
	}
	
	public static Qr applet;

	public static QrCode applet2;

	public static void main(String[] args) {
		applet = new Qr();
		applet.init();
		applet.start();

		applet2 = new QrCode();
		applet2.init();
		applet2.start();

		Screen.initScreen();
	}
}
