package qrcode;

import java.util.ArrayList;

import processing.core.PApplet;
import processing.core.PFont;
import processing.core.PImage;
import qr.Screen;

public class QrCode extends PApplet{
	
	public static PImage[] img;
	PFont font;
	Pixs[][] pixs;
	ArrayList pixlist = new ArrayList();
	public static final int[][] colors = { { 255, 0, 0 }, { 255, 128, 0 },
			{ 128, 128, 0 }, { 0, 255, 0 }, { 0, 128, 0 },
			{ 0, 0, 255 }, { 0, 0, 128 }, { 128, 0, 128 }, };
	private int maxnum = 8;
	private int COLS, ROWS;
	private int cellSize = 2;
	private static final int NOFIN = 10;
	private static int selected = 0;
	private static int pselected = NOFIN;
	private final int defaultFrameRate = 24;
	private int counter = 0;
	private static boolean FINFIN = true;
	private static boolean RUNFIN = false;
	public static boolean autoChanging = true;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public void setup(){
		background(255);
		frameRate(defaultFrameRate);
		colorMode(RGB, 255, 255, 255, 100);
		size(Screen.DEFAULT_SCREEN_WIDTH, Screen.QR_HEIGHT, OPENGL);
		img = new PImage[maxnum];
		font = loadFont("fonts/QRFont-48.vlw");
		
		for(int i = 0; i < maxnum; i++){
			img[i] = loadImage("img/qr" + i +".gif");
			
			COLS = img[i].width / cellSize;
			ROWS = img[i].height / cellSize;
			
			pixs = new Pixs[COLS][ROWS];
			
			for(int j = 0; j < COLS; j++){
				for(int k = 0; k < ROWS; k++){
					pixs[j][k] = new Pixs(this, i, j, k, cellSize);
				}
			}
			
			pixlist.add(pixs);
		}
	}
	
	public void draw(){
		background(255);
		for(int i = 0; i < COLS; i++){
			for(int j = 0; j < ROWS; j++){
				((Pixs[][])pixlist.get(selected))[i][j].draw();
				if(pselected != 10)
					((Pixs[][])pixlist.get(pselected))[i][j].draw();
			}
		}
		if(FINFIN && RUNFIN){
			counter++;
		}
		
		if(autoChanging && counter > defaultFrameRate * 30){
			counter = 0;
			FINFIN = false;
			RUNFIN = false;
			int pselected = selected;
			int selected = QrCode.selected + 1;
			if(selected > maxnum - 1){
				selected = 0;
			}
			int rand = (int)(Math.random() * 5);
			for(int i = 0; i < COLS; i++){
				for(int j = 0; j < ROWS; j++){
					((Pixs[][])pixlist.get(pselected))[i][j].setMode(rand + 10);
					((Pixs[][])pixlist.get(selected))[i][j].setMode(rand);
				}
			}
			QrCode.pselected = pselected;
			QrCode.selected = selected;
//			System.out.println("now is : pselected = " + pselected + ", selected = " + selected);
		}
		
		drawText();
	}
	
	private void drawText(){
		pushMatrix();
		translate(width * 0.763f, 50);
		noStroke();
		fill(0, 180.0f * 100.0f/255.0f);
		textFont(font, (int)(48 * (float)(Screen.screenSize[0] / 1024.0f)));
		String imgString = "qr:" + selected;
		text(imgString, 0, 0);
		popMatrix();
	}
	
	public void keyPressed(){
		if(keyCode == 37 || keyCode == 39){
			if(keyCode == 37){
				counter = 0;
				FINFIN = false;
				RUNFIN = false;
				int pselected = selected;
				int selected = QrCode.selected + 1;
				if(selected > maxnum - 1){
					selected = 0;
				}
				int rand = (int)(Math.random() * 5);
				for(int i = 0; i < COLS; i++){
					for(int j = 0; j < ROWS; j++){
						((Pixs[][])pixlist.get(pselected))[i][j].setMode(rand + 10);
						((Pixs[][])pixlist.get(selected))[i][j].setMode(rand);
					}
				}
				QrCode.pselected = pselected;
				QrCode.selected = selected;
			}else if(keyCode == 39){
				counter = 0;
				FINFIN = false;
				RUNFIN = false;
				int pselected = selected;
				int selected = QrCode.selected - 1;
				if(selected < 0){
					selected = maxnum - 1;
				}
				int rand = (int)(Math.random() * 5);
				for(int i = 0; i < COLS; i++){
					for(int j = 0; j < ROWS; j++){
						((Pixs[][])pixlist.get(pselected))[i][j].setMode(rand + 10);
						((Pixs[][])pixlist.get(selected))[i][j].setMode(rand);
					}
				}
				QrCode.pselected = pselected;
				QrCode.selected = selected;
			}
		}
		switch(key){
		case 112:		// F1
		case 113:		// F2
		case 114:		// F3
		case 115:		// F4
		case 116:		// F5
		case 117:		// F6
		case 118:		// F7
		case 119:		// F8
		case 120:		// F9
			Screen.showGUI();
			break;
		}
	}
	
	public void reloadFont(){
		font = loadFont("fonts/QRFont-48.vlw");
	}
	
	public void setFINFIN(boolean b){
		if(FINFIN != b)
			FINFIN = b;
	}
	
	public void setRUNFIN(boolean b){
		if(RUNFIN != b)
			RUNFIN = b;
	}
	
}
